#include <sourcemod>
#include <sdktools>
#include <morecolors>

#pragma semicolon 1
#define PLUGIN_VERSION "1.3.5"

//ConVars
ConVar sStatsEnabled = null;
ConVar sShowStatsOnRound = null;
ConVar sShowStatsOnMap = null;
ConVar sStatsType = null;
ConVar sMaxRounds = null;
ConVar sWinLimit = null;
ConVar sCheckMapEndBy = null;
ConVar sChatTime;

// stats
int timeleft;
int firstblood = 0;
int countround = 0;
int AssisterID[MAXPLAYERS+1];
int kills[MAXPLAYERS+1];
int hs[MAXPLAYERS+1];
int knives[MAXPLAYERS+1];
int hits[MAXPLAYERS+1];
int assists[MAXPLAYERS+1];
int grenade[MAXPLAYERS+1];

int assistsEnd[MAXPLAYERS+1];
int killsEnd[MAXPLAYERS+1];
int hsEnd[MAXPLAYERS+1];
int knivesEnd[MAXPLAYERS+1];
int hitsEnd[MAXPLAYERS+1];
int grenadeEnd[MAXPLAYERS+1];

float damage1[MAXPLAYERS+1];
float damage1End[MAXPLAYERS+1];
float DamageGiver[MAXPLAYERS][MAXPLAYERS];

char KillerName[MAX_NAME_LENGTH];
char VictimName[MAX_NAME_LENGTH];

bool IamAssisted[MAXPLAYERS];
bool LastRound;

public Plugin myinfo = 
{
	name = "[CSS] SLAYER Advance Round Stats",
	author = "SLAYER",
	description = "Show Advance stats on Round End and on Map End (Mvp, Winner, Headshot kills, Knife kills, Total Damage Given, etc)",
	version = PLUGIN_VERSION,
	url = "https://forums.alliedmods.net/member.php?u=293943"
};

public void OnPluginStart()
{
	CreateConVar("advance_stats_version", PLUGIN_VERSION, "Advance Stats plugin version. Please don't change me!", FCVAR_REPLICATED|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	sStatsEnabled = CreateConVar("advance_stats_enabled", "1", "Enable/disable Advance Stats plugin. (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sShowStatsOnRound = CreateConVar("advance_stats_show_round", "1", "Enable/disable Show Advance Stats on Round End", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sShowStatsOnMap = CreateConVar("advance_stats_show_map", "1", "Enable/disable Show Advance Stats on Map End", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sStatsType = CreateConVar("advance_stats_type", "3", "Advance Stats Show Type (1 = Chat, 2 = Hint, 3 = Both)", FCVAR_NOTIFY);
	sCheckMapEndBy = CreateConVar("advance_stats_map_end_type", "2", "Check Map End Reason by (1 = Timeleft, 2 = Maxrounds, 3 = Winlimit)", FCVAR_NOTIFY);
	sMaxRounds = FindConVar("mp_maxrounds");
	sWinLimit = FindConVar("mp_winlimit");
	sChatTime = FindConVar("mp_chattime");
	HookEvent("round_start", Event_RoundStart);
	HookEvent("round_end", Event_OnRoundEnd);
	HookEvent("player_hurt", Event_PlayerHurt);
	HookEvent("player_death", Event_PlayerDeath);
	AutoExecConfig(true, "SLAYER_Advance_Stats");
}
public void OnMapStart()
{
	countround = 0;
	if(sStatsEnabled.BoolValue)
	{
		if(sChatTime.IntValue < 10)ServerCommand("sm_cvar mp_chattime 10");
		CreateTimer(1.0, TimerCount, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
	}
	
}
public Action TimerCount(Handle timer)
{
	if(sStatsEnabled.BoolValue && sCheckMapEndBy.IntValue == 1)
	{
		int timelimit;
		if(GetMapTimeLimit(timelimit) && timelimit == 0) return Plugin_Stop;
		if(GetMapTimeLeft(timeleft))
		{
			if(timeleft < 1)
			{
				LastRound = true;
				return Plugin_Stop;
			}
			else LastRound = false;
		}
	}
	else return Plugin_Stop;
	return Plugin_Continue;
}
public void OnMapEnd()
{
	if(sStatsEnabled.BoolValue)
	{
		for(new i = 1; i < MAXPLAYERS; i++) // reset stats
		{
			assistsEnd[i] = 0;
			killsEnd[i] = 0;
			hsEnd[i] = 0;
			knivesEnd[i] = 0;
			damage1End[i] = 0.0;
			hitsEnd[i] = 0;
			grenadeEnd[i] = 0;
		}
	}
}
public Event_PlayerDisconnect(Handle event, const char[] name, bool dontBroadcast)
{
	if(sStatsEnabled.BoolValue)
	{
		int attacker = GetClientOfUserId(GetEventInt(event, "userid"));
		kills[attacker] = 0;
		hs[attacker] = 0;
		knives[attacker] = 0;
		damage1[attacker] = 0.0;
		hits[attacker] = 0;
		assists[attacker] = 0;
		grenade[attacker] = 0;
		AssisterID[attacker] = 0;
		DamageGiver[attacker][attacker] = 0.0;
				
	}
}
public void Event_RoundStart(Handle event, const char[] name, bool dontBroadcast)
{
	if(sStatsEnabled.BoolValue)
	{
		firstblood = 0;
		for(new i = 1; i < MAXPLAYERS; i++) // reset stats
		{
			IamAssisted[i] = false;
			kills[i] = 0;
			hs[i] = 0;
			knives[i] = 0;
			damage1[i] = 0.0;
			hits[i] = 0;
			assists[i] = 0;
			grenade[i] = 0;
			DamageGiver[i][i] = 0.0; 
			AssisterID[i] = 0;
		}
	}
}
public void Event_OnRoundEnd(Handle event, const char[] name, bool dontBroadcast)
{
	if(sStatsEnabled.BoolValue)
	{
		sMaxRounds = FindConVar("mp_maxrounds");
		sWinLimit = FindConVar("mp_winlimit");
		int ctscore = GetTeamScore(3);
		int tscore = GetTeamScore(2);
		countround = (ctscore+tscore);
		if(sShowStatsOnRound.BoolValue)
		{
			int WinningTeam = GetEventInt(event, "winner");
			int noob = 0;
			int mostkills = 0;
			int mosths = 0;
			int mostknives = 0;
			int mostassists = 0;
			int mostgrenades = 0;
			char Winner[32];
			if(WinningTeam == 3){Winner = "Counter-Terrorist";}
			if(WinningTeam == 2){Winner = "Terrorist";}
			for(new i = 1; i < MaxClients; i++) // Get kills, Headshots and knife kills
			{
				if(IsClientInGame(i) && kills[i] > 0)
				{
					if(kills[i] > kills[mostkills] || kills[i] == kills[mostkills] && damage1[i] > damage1[mostkills])
					{
						mostkills = i;
					}
					if(hs[i] > 0 && (hs[i] > hs[mosths] || hs[i] == hs[mosths]))
					{
						mosths = i;
					}
					if(knives[i] > 0 && (knives[i] > knives[mostknives] || knives[i] == knives[mostknives]))
					{
						mostknives = i;
					}
					if(grenade[i] > 0 && (grenade[i] > grenade[mostgrenades] || grenade[i] == grenade[mostgrenades]))
					{
						mostgrenades = i;
					}
				}
				if(IsClientInGame(i) && assists[i] > 0 && (assists[i] > assists[mostassists] || assists[i] == assists[mostassists]))
				{
					mostassists = i;
				}
				if(IsClientInGame(i) && !IsClientSourceTV(i) && GetClientTeam(i) != 1 && kills[i] <= 0 && damage1[i] <= 0)
				{
					noob = i;
				}
			}
			char noobname[MAX_NAME_LENGTH];
			GetClientName(noob, noobname, sizeof(noobname));
			char mvpname[MAX_NAME_LENGTH];
			GetClientName(mostkills, mvpname, sizeof(mvpname));
			char hname[MAX_NAME_LENGTH];
			GetClientName(mosths, hname, sizeof(hname));
			char kname[MAX_NAME_LENGTH];
			GetClientName(mostknives, kname, sizeof(kname));
			char Aname[MAX_NAME_LENGTH];
			GetClientName(mostassists, Aname, sizeof(Aname));
			char Gname[MAX_NAME_LENGTH];
			GetClientName(mostgrenades, Gname, sizeof(Gname));
			if(sStatsType.IntValue == 1 || sStatsType.IntValue == 3) // show in chat
			{
				CPrintToChatAll("{crimson}==========[{aqua}★ {green}Round{white}-{green}Stats {aqua}★{crimson}]==========");
				if(WinningTeam == 2)CPrintToChatAll("{aqua}★ {white}Winner{aqua}: {red}%s", Winner);
				if(WinningTeam == 3)CPrintToChatAll("{aqua}★ {white}Winner{aqua}: {blue}%s", Winner);
				if(mostkills > 0)CPrintToChatAll("{aqua}★ {crimson}%s {white}is {aqua}MVP {white}with {aqua}%i {green}Kills, {aqua}%0.0f {yellow}Damage, {aqua}%i {lime}Hits", mvpname, kills[mostkills], damage1[mostkills], hits[mostkills]); // Name of MVP player
				if(mosths > 0)CPrintToChatAll("{aqua}★ {white}HeadHunter{aqua}: {aqua}%s {white}({aqua}%i{white})", hname, hs[mosths]); // HeadHunter of Round by which player
				if(mostknives > 0)CPrintToChatAll("{aqua}★ {white}Most Knife kills{aqua}: {yellow}%s {white}({yellow}%i{white})", kname, knives[mostknives]); // Most Knife Kills in Round by which player
				if(mostgrenades > 0)CPrintToChatAll("{aqua}★ {white}Most Grenade kills{aqua}: {lime}%s {white}({lime}%i{white})", Gname, grenade[mostgrenades]); // Most Grenades Kills in Round by which player
				if(mostassists > 0)CPrintToChatAll("{aqua}★ {white}Most Assists {aqua}: {gold}%s {white}({gold}%i{white})", Aname, assists[mostassists]); // Most Assist kills in Round by which player
				if(noob > 0)CPrintToChatAll("{aqua}★ {white}Noob of the Round{aqua}: {crimson}%s", noobname); // Name of Noob player of Round
				CPrintToChatAll("{crimson}==========[{aqua}★ {green}Round{white}-{green}Stats {aqua}★{crimson}]==========");
			}
			if(sStatsType.IntValue == 2 || sStatsType.IntValue == 3) // show in Hint
			{
				
				if(mostkills > 0 && mosths > 0 && mostknives > 0 && mostgrenades > 0)PrintHintTextToAll("%s is MVP with %i Kills\nHeadHunter: %s (%i)\nMost Knife kills: %s (%i)\nMost Grenade kills: %s (%i)\nNoob: %s", mvpname, kills[mostkills], hname, hs[mosths], kname, knives[mostknives], Gname, grenade[mostgrenades], noobname);
				else if(mostkills > 0 && mosths > 0 && mostgrenades > 0)PrintHintTextToAll("%s is MVP with %i Kills\nHeadHunter: %s %i\nMost Grenade kills: %s (%i)\nNoob: %s", mvpname, kills[mostkills], hname, hs[mosths], Gname, grenade[mostgrenades], noobname);
				else if(mostkills > 0 && mosths > 0 && mostknives > 0)PrintHintTextToAll("%s is MVP with %i Kills\nHeadHunter: %s %i\nMost Grenade kills: %s (%i)\nNoob: %s", mvpname, kills[mostkills], hname, hs[mosths], kname, knives[mostknives], noobname);
				else if(mostkills > 0 && mostknives > 0 && mostgrenades > 0)PrintHintTextToAll("%s is MVP with %i Kills\nMost Knife kills: %s (%i)\nMost Grenade kills: %s (%i)\nNoob: %s", mvpname, kills[mostkills], kname, knives[mostknives], Gname, grenade[mostgrenades], noobname);
				else if(mostkills > 0 && mostknives > 0)PrintHintTextToAll("%s is MVP with %i Kills, %0.0f Damage, %i Hits\nMost Knife kills: %s (%i)\nNoob: %s", mvpname, kills[mostkills], damage1[mostkills], hits[mostkills], kname, knives[mostknives], noobname);
				else if(mostkills > 0 && mostgrenades > 0)PrintHintTextToAll("%s is MVP with %i Kills, %0.0f Damage, %i Hits\nMost Grenade kills: %s (%i)\nNoob: %s", mvpname, kills[mostkills], damage1[mostkills], hits[mostkills], Gname, grenade[mostgrenades], noobname);
				else if(mostkills > 0 && mosths > 0)PrintHintTextToAll("%s is MVP with %i Kills, %0.0f Damage, %i Hits\nHeadHunter: %s (%i)\nNoob: %s", mvpname, kills[mostkills], damage1[mostkills], hits[mostkills], hname, hs[mosths], noobname);
				else if(mostkills > 0)PrintHintTextToAll("%s is MVP with %i Kills, %0.0f Damage, %i Hits\nNoob: %s", mvpname, kills[mostkills], damage1[mostkills], hits[mostkills], noobname);
			}
		}
		if(sCheckMapEndBy.IntValue == 1 && LastRound == true)
		{
			MapEndText();
		}
		if(sCheckMapEndBy.IntValue == 2 && sMaxRounds.IntValue > 0 && sMaxRounds.IntValue == countround)
		{
			MapEndText();
		}
		if(sCheckMapEndBy.IntValue == 3 && sWinLimit.IntValue > 0 && sWinLimit.IntValue == ctscore || sWinLimit.IntValue == tscore)
		{
			MapEndText();
		}
	}
}

void MapEndText()
{
	if(sStatsEnabled.BoolValue)
    {
    	if(sShowStatsOnMap.BoolValue)
    	{
			int ctscore = GetTeamScore(3);
			int tscore = GetTeamScore(2);
			int noobEnd = 0;
			int mostkillsEnd = 0;
			int mosthsEnd = 0;
			int mostknivesEnd = 0;
			int mostassistsEnd = 0;
			int mostgrenadesEnd = 0;
			char WinnerEnd[32];
			if(ctscore > tscore){WinnerEnd = "Counter-Terrorist";}
			if(tscore > ctscore){WinnerEnd = "Terrorist";}
			for(new i = 1; i < MaxClients; i++) // Get kills, Headshots and knife kills
			{
				if(IsClientInGame(i) && kills[i] > 0)
				{
					if(killsEnd[i] > killsEnd[mostkillsEnd] || killsEnd[i] == killsEnd[mostkillsEnd] && damage1End[i] > damage1End[mostkillsEnd])
					{
						mostkillsEnd = i;
					}
					if(hsEnd[i] > 0 && (hsEnd[i] > hsEnd[mosthsEnd] || hsEnd[i] == hsEnd[mosthsEnd]))
					{
						mosthsEnd = i;
					}
					if(knivesEnd[i] > 0 && (knivesEnd[i] > knivesEnd[mostknivesEnd] || knivesEnd[i] == knivesEnd[mostknivesEnd]))
					{
						mostknivesEnd = i;
					}
					if(grenadeEnd[i] > 0 && (grenadeEnd[i] > grenadeEnd[mostgrenadesEnd] || grenadeEnd[i] == grenadeEnd[mostgrenadesEnd]))
					{
						mostgrenadesEnd = i;
					}
				}
				if(IsClientInGame(i) && assistsEnd[i] > 0 && (assistsEnd[i] > assistsEnd[mostassistsEnd] || assistsEnd[i] == assistsEnd[mostassistsEnd]))
				{
					mostassistsEnd = i;
				}
				if(IsClientInGame(i) && !IsClientSourceTV(i) && GetClientTeam(i) != 1 && killsEnd[i] <= 0 && damage1End[i] <= 0)
				{
					noobEnd = i;
				}
			}
			char noobnameEnd[MAX_NAME_LENGTH];
			GetClientName(noobEnd, noobnameEnd, sizeof(noobnameEnd));
			char mvpnameEnd[MAX_NAME_LENGTH];
			GetClientName(mostkillsEnd, mvpnameEnd, sizeof(mvpnameEnd));
			char hnameEnd[MAX_NAME_LENGTH];
			GetClientName(mosthsEnd, hnameEnd, sizeof(hnameEnd));
			char knameEnd[MAX_NAME_LENGTH];
			GetClientName(mostknivesEnd, knameEnd, sizeof(knameEnd));
			char AnameEnd[MAX_NAME_LENGTH];
			GetClientName(mostassistsEnd, AnameEnd, sizeof(AnameEnd));
			char GnameEnd[MAX_NAME_LENGTH];
			GetClientName(mostgrenadesEnd, GnameEnd, sizeof(GnameEnd));
			if(sStatsType.IntValue == 1 || sStatsType.IntValue == 3) // show in chat
			{
				CPrintToChatAll("{crimson}==========[{aqua}★ {green}Map{white}-{green}Stats {aqua}★{crimson}]==========");
				if(tscore > ctscore)CPrintToChatAll("{aqua}★ {white}Winner{aqua}: {red}%s", WinnerEnd);
				if(ctscore > tscore)CPrintToChatAll("{aqua}★ {white}Winner{aqua}: {blue}%s", WinnerEnd);
				if(mostkillsEnd > 0)CPrintToChatAll("{aqua}★ {crimson}%s {white}is {aqua}MVP {white}with {aqua}%i {green}Kills {white}by Giving \n{aqua}★{yellow} Damage {aqua}%0.0f {white}in {aqua}%i {lime}Hits", mvpnameEnd, killsEnd[mostkillsEnd], damage1End[mostkillsEnd], hitsEnd[mostkillsEnd]); // Name of MVP player
				if(mosthsEnd > 0)CPrintToChatAll("{aqua}★ {white}HeadHunter {aqua}: {aqua}%s {white}({aqua}%i{white})", hnameEnd, hsEnd[mosthsEnd]); // HeadHunter of Map by which player
				if(mostknivesEnd > 0)CPrintToChatAll("{aqua}★ {white}Most Knife kills {aqua}: {yellow}%s {white}({yellow}%i{white})", knameEnd, knivesEnd[mostknivesEnd]); // Most Knife Kills in Map by which player
				if(mostgrenadesEnd > 0)CPrintToChatAll("{aqua}★ {white}Most Grenade kills {aqua}: {lime}%s {white}({lime}%i{white})", GnameEnd, grenadeEnd[mostgrenadesEnd]); // Most Grenades Kills in Map by which player
				if(mostassistsEnd > 0)CPrintToChatAll("{aqua}★ {white}Most Assists {aqua}: {gold}%s {white}({gold}%i{white})", AnameEnd, assistsEnd[mostassistsEnd]); // Most Assists Kills in Map and by which player
				if(noobEnd > 0)CPrintToChatAll("{aqua}★ {white}Noob of the map {aqua}: {crimson}%s", noobnameEnd); // Name of Noob player of Map
				CPrintToChatAll("{crimson}==========[{aqua}★ {green}Map{white}-{green}Stats {aqua}★{crimson}]==========");
			}
		}
	}
}
public Action Event_PlayerHurt(Handle event, const char[] name, bool dontBroadcast)
{
	if(sStatsEnabled.BoolValue)
	{
		int attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
		int victim = GetClientOfUserId(GetEventInt(event, "userid"));
		if(attacker == 0)
		{
			return;
		}
		if(IsClientConnected(attacker) && IsClientInGame(attacker) && GetClientTeam(attacker) != GetClientTeam(victim))
		{
			float dmg = GetEventFloat(event, "dmg_health");
			damage1[attacker] += dmg;
			damage1End[attacker] += dmg;
			hits[attacker]++;
			hitsEnd[attacker]++;
			if(IamAssisted[victim] == false)
			{
				RoundFloat(dmg);
				DamageGiver[attacker][victim] += dmg;
				if(DamageGiver[attacker][victim] > 40.0 && IamAssisted[victim] == false)
				{
					AssisterID[victim] = attacker;
					IamAssisted[victim] = true;
				}
			}
		}
	}
}
public Event_PlayerDeath(Handle event, const char[] name, bool dontBroadcast)
{
	if(sStatsEnabled.BoolValue)
	{
		int attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
		int victim = GetClientOfUserId(GetEventInt(event, "userid"));
		if(attacker == 0)
		{
			return;
		}
		GetClientName(victim, VictimName, sizeof(VictimName));
		GetClientName(attacker, KillerName, sizeof(KillerName));
		if(GetClientTeam(attacker) != GetClientTeam(victim))
		{
			kills[attacker]++;
			killsEnd[attacker]++;
			firstblood++;
			if(firstblood == 1)
			{
				if(sStatsType.IntValue == 1 || sStatsType.IntValue == 3)CPrintToChatAll("{crimson}[{aqua}★ {green}Round{white}-{green}Stats {aqua}★{crimson}] {green}%s {white}is the First Blooder by killing {aqua}%s", KillerName, VictimName);
				if(sStatsType.IntValue == 2 || sStatsType.IntValue == 3)PrintHintTextToAll("[★ Round-Stats ★]\n%s is the First Blooder by killing %s", KillerName, VictimName);
			}
			if(GetEventBool(event, "Headshot"))
			{
				hs[attacker]++;
				hsEnd[attacker]++;
				if(sStatsType.IntValue == 1 || sStatsType.IntValue == 3)CPrintToChatAll("{crimson}[{aqua}★ {green}Round{white}-{green}Stats {aqua}★{crimson}] {green}%s {white}kill {aqua}%s {white}with {gold}Headshot", KillerName, VictimName);
				if(sStatsType.IntValue == 2 || sStatsType.IntValue == 3)PrintHintTextToAll("[★ Round-Stats ★]\n%s kill %s with Headshot", KillerName, VictimName);
			}
			char weapon[13];
			GetEventString(event, "weapon", weapon, sizeof(weapon));
			if(StrEqual(weapon, "knife"))
			{
				knives[attacker]++;
				knivesEnd[attacker]++;
				if(sStatsType.IntValue == 1 || sStatsType.IntValue == 3)CPrintToChatAll("{crimson}[{aqua}★ {green}Round{white}-{green}Stats {aqua}★{crimson}] {green}%s {white}kill {aqua}%s {white}with {gold}Knife", KillerName, VictimName);
				if(sStatsType.IntValue == 2 || sStatsType.IntValue == 3)PrintHintTextToAll("[★ Round-Stats ★]\n%s kill %s with Knife", KillerName, VictimName);
			}
			if(StrEqual(weapon, "hegrenade"))
			{
				if(sStatsType.IntValue == 1 || sStatsType.IntValue == 3)CPrintToChatAll("{crimson}[{aqua}★ {green}Round{white}-{green}Stats {aqua}★{crimson}] {green}%s {white}kill {aqua}%s {white}with {gold}Grenade", KillerName, VictimName);
				if(sStatsType.IntValue == 2 || sStatsType.IntValue == 3)PrintHintTextToAll("[★ Round-Stats ★]\n%s kill %s with Grenade", KillerName, VictimName);
				grenade[attacker]++;
				grenadeEnd[attacker]++;
			}
			if(IamAssisted[victim] == true)
			{
				if(AssisterID[victim] != attacker)
				{
					assists[AssisterID[victim]]++;
					assistsEnd[AssisterID[victim]]++;
					if(sStatsType.IntValue == 1 || sStatsType.IntValue == 3)CPrintToChat(AssisterID[victim], "{crimson}[{aqua}★ {green}Round{white}-{green}Stats {aqua}★{crimson}] {lime}You {crimson}Assisted {aqua}%s. {white}Your Total {crimson}Assists {white}in this round are: {lime}%d", VictimName, assists[AssisterID[victim]]);
					if(sStatsType.IntValue == 2 || sStatsType.IntValue == 3)PrintHintText(AssisterID[victim], "[★ Round-Stats ★] You Assisted %s. {white}Your Total Assists in this round are: %d", VictimName, assists[AssisterID[victim]]);
				}
			}
		}
	}
}